<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:rich="http://richfaces.org/rich"
                xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.webservice.tester.ManagerKeystores']}"/>
    <ui:define name="body">

        <h:form id="globalForm">
            <gri:panel>
                <f:facet name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.webservice.tester.Keystores']}"/>
                </f:facet>

                <rich:dataTable id="keystoreTable"
                                value="#{keystoreManager.keystores}" var="keystore"
                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                render="ds">
                    <g:column sortBy="#{'id'}" sortOrder="descending">
                        <ui:define name="header">#{messages['net.ihe.gazelle.simulators.Id']}</ui:define>
                        <h:outputText value="#{keystore.id}"/>
                    </g:column>
                    <g:column sortBy="#{'label'}" filterBy="#{'label'}">
                        <ui:define name="header">#{messages['gazelle.simu.Name']}</ui:define>
                        <h:outputText value="#{keystore.label}"/>
                    </g:column>
                    <g:column sortBy="#{'oid'}" filterBy="#{'oid'}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.webservice.tester.Path']}</ui:define>
                        <h:outputText value="#{keystore.path}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                        <a4j:commandLink render="formPopupDelete"
                                         actionListener="#{keystoreManager.setKeystoreToDelete(keystore)}"
                                         oncomplete="jq162('#popupDelete').modal('show');">
                            <s:span title="Delete keystore" styleClass="gzl-icon-trash-o"/>
                        </a4j:commandLink>

                        <s:span styleClass="gzl-icon-circle-green" title="Default keystore"
                                rendered="#{keystore.isDefaultKeystore() == true}"/>
                        <a4j:commandLink render="globalForm" rendered="#{keystore.isDefaultKeystore() == false}"
                                         actionListener="#{keystoreManager.setDefault(keystore)}">
                            <s:span title="Set to default" styleClass="gzl-icon-checked"/>
                        </a4j:commandLink>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="keystoreTable"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>


                <f:facet name="footer">
                    <a4j:commandButton styleClass="gzl-btn-blue" value="#{messages['net.ihe.gazelle.webservice.tester.AddAKeystore']}"
                                       actionListener="#{keystoreManager.addNewKeystore()}"
                                       render="globalForm"
                                       rendered="#{keystoreManager.addKeystore == false}"/>
                </f:facet>
            </gri:panel>


            <gri:panel rendered="#{keystoreManager.addKeystore}">

                <f:facet name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.webservice.tester.AddAKeystore']}"/>
                </f:facet>

                <rich:fileUpload id="uploadCertificate"
                                 fileUploadListener="#{keystoreManager.uploadEventListener}"
                                 maxFilesQuantity="1" listHeight="60px" immediateUpload="true"
                                 acceptedTypes="jks" ontyperejected="ontyperejected()">
                    <a4j:ajax event="uploadcomplete" render="keystorePanel"/>
                    <a4j:jsFunction name="ontyperejected"
                                    actionListener="#{keystoreManager.setMessageInvalidFileType()}"/>
                </rich:fileUpload>

                <s:decorate template="/layout/form/_edit.xhtml">
                    <ui:param name="id" value="nameInput"/>
                    <ui:define name="label">#{messages['gazelle.simu.Name']}</ui:define>
                    <h:inputText id="nameInput" value="#{keystoreManager.newKeystore.label}"
                                 required="true" styleClass="form-control"/>
                </s:decorate>
                <s:decorate template="/layout/form/_edit.xhtml">
                    <ui:param name="id" value="passwordInput"/>
                    <ui:define name="label">#{messages['users.Password']}</ui:define>
                    <h:inputSecret id="passwordInput" value="#{keystoreManager.newKeystore.password}"
                                   styleClass="form-control"/>
                </s:decorate>


                <f:facet name="footer">
                    <a4j:commandButton id="saveKeystore" styleClass="gzl-btn-green" value="#{messages['net.ihe.gazelle.webservice.tester.Validate']}"
                                       actionListener="#{keystoreManager.merge()}"
                                       render="globalForm"/>
                    <a4j:commandButton id="cancel" styleClass="gzl-btn" value="#{messages['users.Cancel']}"
                                       actionListener="#{keystoreManager.cancel()}"
                                       render="globalForm" immediate="true"/>
                </f:facet>

            </gri:panel>
        </h:form>

        <h:form id="formPopupDelete">
            <ui:decorate template="/layout/popup/_popup_footer.xhtml">
                <ui:param name="popup_id" value="popupDelete"/>
                <p>#{messages['net.ihe.gazelle.webservice.tester.AreYouSureYouWantToDeleteThisKeystore']}</p>
                <ui:define name="popup_footer">
                    <h:commandButton value="#{messages['users.Cancel']}"
                                     styleClass="btn btn-default"
                                     oncomplete="jq162('#popupDelete').modal('hide');"/>
                    <a4j:commandButton value="#{messages['users.Delete']}"
                                       styleClass="gzl-btn-red"
                                       actionListener="#{keystoreManager.delete()}"
                                       oncomplete="jq162('#popupDelete').modal('hide');"
                                       render="globalForm"/>
                </ui:define>
            </ui:decorate>
        </h:form>

    </ui:define>
</ui:composition>
